//TESTER
//Will need to modify this to allow only one connection since we only want one app
//per laptop talking to the database.  This should also simplify the code a great deal.
//We also want to keep the DB connection open always to improve time delay.  Plus, we
//dont have to worry about connections being left open and the Flash app worrying about
//what connection number it is.  Instead we will send back 1 or 0 for success



// XML MESSAGE FORMATS TO PASS TO THIS PROGRAM
/*
 * Initiate a connection:
 * <flashLogon>
  <IPAddr>192.168.88.1</IPAddr> 
  <Login>postgres</Login> 
  <Password>admin_password</Password> MUST USE a space if there is no password!
  <Database>desired_db</Database>
</flashLogon>

Send a query:
<flashCommand>
  <Command>SELECT * FROM Table1</Command>
</flashCommand>

After a connection is made:
<Connection>
	status=granted
</Connection>

If the database connection can not be made:
<Connection>
	status=failed
</Connection>
As a string: <Connection status=failed></Connection>

To close a connection:
<flashCommand>
	<Command>disconnect</Command> 
</flashCommand>

After a command is processed:
<Return
	query = thequeryforthisresultset
	numReturned = 3>
	<1 attr1 = val1  attr2 = val2 ></1>
    <2 attr1 = val3  attr2 = val4 ></2>
    ...
</Return>

Upon Error:
<Error>
	errortype = the error message
</Error>
*/
/****************************************
 * oSckSrv
 * @author Matthew Teeter
 * Java Flash to PostgreSQL translator
 * based off an example by Razvan Petrescu
 ****************************************/

import java.net.*;
import java.io.*;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.w3c.dom.Node;
import java.util.ArrayList;

public class oSckSrv {
	public static void main(String[] args) {
		while (true)
		{
			oSckSrv s = new oSckSrv();
		}
	}
	/*******************************
	 * Members
	 *******************************/
	ServerSocket sckSrv = null;
	int portNumber = 43933;
	Socket sck = null;
	BufferedReader ino = null;
	PrintWriter outo = null;
	//ArrayList connections = null;
	String IPAddr = "";
	String Login = "";
	String Password = "";
	String Database = "";
	String Command = "";
	String Output = "";
	//int Connection;
	final static int _LOGON = 1;
	final static int _COMMAND = 2;
	final static int _UNKNOWN = 0;
	
	dbConn connection;

	
	/********************************
	 * Constructor
	 ********************************/
	public oSckSrv()
	{
		//begin:
		try
		{
			sckSrv = new ServerSocket(portNumber);
			System.out.println( "Waiting for connection. Port: " + portNumber );
			//connections = new ArrayList();

			// Main loop
			sck = sckSrv.accept();
			System.out.println( "\n[" + System.currentTimeMillis() +  "] accepted: " + sck.getInetAddress() );
			ino = new BufferedReader( new InputStreamReader( sck.getInputStream()));
			System.out.println("\tIn-stream created.");

			outo = new PrintWriter( sck.getOutputStream(), true );
			System.out.println("\tOut-stream created.");		
				String msg = ino.readLine();
				if( msg.charAt( 0 ) == '\0' )
					 msg = msg.substring( 1 );
				if (msg.equals("")|| msg == null)
				{//erroneous input, usually sent when Flash app closed
					//use this until we know how to disconnect gracefully from flash
					System.out.println("Flash app closed");
					outo.close();
					ino.close();
					sck.close();
					return;
				}
				//String returnQuery = "<Return query=\"SELECT album_id FROM usb_album WHERE (display_order &gt;= '1' AND display_order &lt;= '999') ORDER BY display_order\" numReturned='0'> <1 album_id='1'></1> <2 album_id='2'></2><3 album_id='3'></Return>\0";
				
				String returnQuery = "<Return query=\"SELECT * FROM usb_song WHERE song_id = 90\" numReturned='0'> <1 song_id='90' display_order='81' album_id='4' filename='Le Chemin de Fer, op. 27.mid' modify_time='null' count='0' access_time='0001-01-01 00:00:00' dkv_id='null' add_file='null' rating='null' mark='null' volume_offset='null' your_record='null' comment='null' title='Le Chemin de Fer, op. 27.mid' subtitle='Le Chemin de Fer, op. 27.mid' format='SMF0' length='null' type='OTHER' track='null' protect='null' instrument='null' copyright='null' counter_type='null' genre='null' skip='null' guide='null' cd_id='null' audio_volume='null' audio_pitch='null' sync_id='null' revision='NOR0.00' l_part_ch='null' r_part_ch='null' vel_curve='null' guide_part='null'></1></Return>\0";
				System.out.println( returnQuery );
				outo.print( returnQuery );
				outo.flush();
		}
		catch( java.io.IOException e ){
			//System.out.println("Closing connection to Flash");
			if (outo != null)
				outo.close();
			try{
			if (ino != null) ino.close();
			if (sck != null) sck.close();
			}catch(Exception f){System.out.println(f.toString());}
		}
		catch( Exception e ){
			System.out.println(e.toString());
		}
	}



	/********************************
	 * SendConnectionInfo
	 * Create XML file for connection
	 ********************************/
	public String sendConnectionInfo()
	{
		return "<Connection " + "status='granted'" + "></Connection>\0"; // \0 required by Flash
	}
	public String sendConnectionFailedInfo()
	{
		return "<Connection " + "status='failed'" + "></Connection>\0"; // \0 required by Flash
	}

	/********************************
	 * ParseReceivedXML
	 ********************************/
	public int parseReceivedXML( String xmlStr ){
		try{
			FileOutputStream ftemp = new FileOutputStream( "doc.xml");
			ftemp.write( xmlStr.getBytes());
			ftemp.flush();
			ftemp.close();
			DocumentBuilderFactory oFdb = DocumentBuilderFactory.newInstance();
			DocumentBuilder oBldr = oFdb.newDocumentBuilder();
			Document oDoc = oBldr.parse( "doc.xml" );

			Element oRoot = oDoc.getDocumentElement();
			String sRoot = oRoot.getTagName();

			if( sRoot.compareTo( "flashLogon" ) ==0 )
			{
				System.out.println( "\tLogon request:");
				NodeList list = oRoot.getChildNodes();
				for( int i = 0; i < list.getLength(); i++){

					Node n = list.item( i );
					String nodeName = n.getNodeName();
//					System.out.println( "\t-" + nodeName );
					if( n.getNodeType() == Node.ELEMENT_NODE ){

						Node inner = n.getFirstChild();
						String nodeValue = inner.getNodeValue();
						//System.out.println( "\t\t'" + nodeValue + "'" );

						if( nodeName.compareTo( "IPAddr" ) == 0 )
							IPAddr = nodeValue;
						if( nodeName.compareTo( "Login" ) == 0 )
							Login = nodeValue;
						if( nodeName.compareTo( "Password" ) == 0 )
							Password = nodeValue;
						if( nodeName.compareTo( "Database" ) == 0 )
							Database = nodeValue;
					}
				}
				return oSckSrv._LOGON;
			}
			else if( sRoot.compareTo( "flashCommand" ) ==0 )
			{
				System.out.println( "\tCommand request:");
				NodeList list = oRoot.getChildNodes();
				for( int i = 0; i < list.getLength(); i++){
					Node n = list.item( i );
					String nodeName = n.getNodeName();
					String nodeValue = "";

					if( nodeName == "Command" ){
						nodeValue = n.getFirstChild().getNodeValue();
						Command = nodeValue;
					}

//					if( nodeName == "Connection"){//we dont use this anymo
//							Connection = Integer.parseInt( n.getFirstChild().getNodeValue());
//							nodeValue = String.valueOf( Connection );
//					}

					System.out.println( "\t-" + nodeName + ":" + nodeValue );
				}
				return oSckSrv._COMMAND;
			}
			else
			{
					System.out.println( "\tUnknown client request");
					return oSckSrv._UNKNOWN;
			}
		}
		catch( Exception e ){
			System.out.println( e.toString());
			return oSckSrv._UNKNOWN ;
		}
	}
}
